// dcf.h
/*----------------------------------------------------------------------*/
/*! \file 
--------------------------------------------------------------------------

  	<h3> DCF.H </h3>
  	Version	1.0
  	Revision	$Revision: 1.5 $
 	Copyright 	Thomas Wedemeyer, Email: avr@thomas-wedemeyer.de 
  	Datum		$Date: 2011/08/16 20:45:08 $

	<h3>Datenstrukturen und Prototypen fr DCF-Funktion</h3>

/*----------------------------------------------------------------------*/
#ifndef DCF_H
#define DCF_H

/*----------------------------------------------------------------------*/
// Definition der DCF-Hardware
/*----------------------------------------------------------------------*/
#define DCF_INV				//!< Ausgangssignal DCF-Empfnger invertiert */
//#define DCF_NORMAL			//!< Ausgangssignal DCF-Empfnger nicht invertiert

/*----------------------------------------------------------------------*/
// Strukturen
/*----------------------------------------------------------------------*/

struct	dcf_format {
	volatile	uint8_t		data[8];	//!< Datenbits -> in Blcken in einem Byte gespeichert. 
	volatile	uint8_t		sec;		//!< Sekundenzhler [sec] fr DCF-Auswertung abgeleitet von T1
	volatile	uint8_t		bitcnt;		//!< Bitzhler fr den Empfang
	volatile	uint16_t	tcnt;		//!< Zwischenspeicher fr Zhlerwert Timer 1
	volatile	uint16_t	msec;		//!< MSek-Zhler von T2 abgeleitet
				uint8_t		min;		//!< Minutenzhler dekodiert
				uint8_t		hour;		//!< Stundenzhler
				uint8_t		wkday;		//!< Wochentag
				uint8_t		day;		//!< Tag
				uint8_t		month;		//!< Monat
				uint8_t		year;		//!< Jahr
	volatile 	uint8_t		new;		//!< Flag, das neues Datenframe empfangen...
	volatile	uint8_t		okay;		//!< Daten richtig empfangen und ausgewertet!
};


/*----------------------------------------------------------------------*/
// Prototypen
/*----------------------------------------------------------------------*/
void init_dcf();
void check_dcf();

#endif
